<?php
/**
 * Query Web service
 * Query.php
 * Returns the list of subscribers to an archive.
 * Requires Pear SOAP.
 * Version 0.0.4
 * Copyright (c) 2001-2002 Alexis Grandemange
 * Mail: alexis.grandemange@pagebox.net
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; version
 * 2.1 of the License.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 * A copy of the GNU Lesser General Public License lesser.txt should be
 * included in the distribution.
 */
include("pagebox.inc");
/**
 * queryRelay
 * Make an HTTP GET request to QueryRelay.php, which is the actual client of RepoQuery.
 * Parameters: 
 * archive: archive whose subscribers must be returned
 * deployURL: this deployment URL (to not include in the returned list
 * Returns a subscriber array.
 */
function queryRelay($archive, $deployURL) {
    $loc = "http://" . str_replace("update.php", "QueryRelay.php", $deployURL);
    $query = $loc . '?arch=' . $archive . '&deploy=' . $deployURL;
    $frelay = fopen($query, "r");
    if ($frelay == FALSE)
        return NULL;
    $ra = NULL;
    while (!feof ($frelay)) {
        $item = fgets($frelay, 255);
        $prefix = substr($item, 0, 2);
        if ($prefix == "<b")
            continue;
        // pblog("queryRelay found:" . $item);
        $ra[] = $item;
    }
    // $fclose($frelay);
    return $ra;
}
$status = "";
$PbArchivesObj = NULL;
include_once('SOAP/Server.php');
/**
 * Web service class
 */
class Query {
    var $method_namespace = 'urn:PageBox';
    var $dispatch_map = array();
    var $PbArchivesObj;
    function Query($pao) {
        $this->PbArchs = $pao;
    }
    /**
     * Web service method.
     * Parameters:
     * archive: archive whose subscribers must be returned
     * deployURL: this deployment URL (to not include in the returned list
     * Returns a SOAP_Value aarray of subscribers.
     */
    function GetSubscribers($archive, $deployURL)
    {
        /**
         * With the April 2002 version of Pear SOAP it is not possible to be both a SOAP
         * client and server. So for the moment we call another page, QueryRelay to call
         * RepoQuery.
         * If you have a version without the problem, uncomment
         * $ra = repoQuery($this->PbArchs, $archive, $deployURL);
         * and the Restore pbArchive code below - then PbArchivesObj must be set,
         * comment
         * queryRelay($archive, $deployURL);
         */
        // $ra = repoQuery($this->PbArchs, $archive, $deployURL);
        $ra = queryRelay($archive, $deployURL);
        if ($ra != NULL) {
            $arr = NULL;
            foreach($ra as $item) {
                pblog("Query.GetSubscribers found " . $item);
                $arr[] = new SOAP_Value('item','string', $item);
            }
            if ($arr != NULL)
	        return new SOAP_Value('outputArray', NULL ,$arr);
        }
        $arr[] = "Archive not found";
	return new SOAP_Value('outputArray', NULL ,$arr);
    }    
}
/**
 * Restores pbArchive.
 * Not needed if Query calls QueryRelay.
if (file_exists("pbArchives.pb")) {
  $s = implode("", @file("pbArchives.pb"));
  $PbArchivesObj = unserialize($s);
  pblog("pbArchives restored");
} else {
  $status = "Archive not found";
  pblog("Archive not found");
}
 */
$server = new SOAP_Server;
$soapclass = new Query($PbArchivesObj);
$server->addObjectMap($soapclass);
$server->service($HTTP_RAW_POST_DATA);
?>